points/: points[{a_, b_}, {c_, d_}] :=  Block[{x, y},
   Table[N[{x, y}], {x, a, b, (b - a)/10}, {y, c, d, (d - c)/10}]]
 
attractors/: attractors[f_, {a_, b_}, {c_, d_}, n_] := 
   Block[{x, y}, Table[Nest[iteration[f], N[x + y*I], n], 
     {x, a, b, (b - a)/10}, {y, c, d, (d - c)/10}]]
 
f/: f[x_] := x^4 - 1
 
iteration/: iteration[f_][x_] := x - f[x]/Derivative[1][f][x]
 

colour/: colour[i_, j_] := Which[
         attractor[[i, j]] == 1., RGBColor[1, 0, 0],
         attractor[[i, j]] == 1. I, RGBColor[0, 1, 0],
         attractor[[i, j]] == -1., RGBColor[0, 0, 1],
         attractor[[i, j]] == -1. I, RGBColor[1, 1, 0],
         True, RGBColor[1, 0, 1]]

 
patch/: patch[f_, {a_, b_}, {c_, d_}, n_] := (
        lattice = points[{a, b}, {c, d}];
        attractor = attractors[f, {a, b}, {c, d}, n];
        Show[Table[Graphics[{colour[i, j], Point[lattice[[i, j]]]}],
                                {i, 1, 11}, {j, 1, 11}]])

