secant/: secant[f_, a_][p_] :=
    (one = Block[{x}, Plot[{f[x], (f[p] - f[a]) (x - a)/(p - a) + f[a]},
        {x, a - 1.5, a + 1.5}, Axes -> None, AspectRatio -> Automatic,
                    DisplayFunction -> Identity]]; 
    two = ListPlot[{{a, f[a]}, {p, f[p]}}, DisplayFunction -> Identity];
            Show[one, two, DisplayFunction -> $DisplayFunction])

secant::usage = "secant[f, a][p] plots f and the secant joining (a, f[a])
and (p, f[p])."


tangent/: tangent[f_, a_][x_] := Derivative[1][f][a]*(x - a) + f[a]
 
normal/: normal[f_, a_][x_] := (a - x)/Derivative[1][f][a] + f[a]
 
tangentplot/: tangentplot[f_, a_, {b_, c_}] := 
   Plot[{f[x], tangent[f, a][x]}, {x, b, c}]
 
normalplot/: normalplot[f_, a_, {b_, c_}] := 
   Plot[{f[x], normal[f, a][x]}, {x, b, c}, AspectRatio -> Automatic]
 
tangentfamily/: 
  tangentfamily[f_, {a_, b_, stepsize_:0.1}] := 
   (one = Plot[f[x], {x, a, b}, DisplayFunction -> Identity];
    two =
    Block[{i}, Plot[Release[Table[tangent[f, i][x], {i, a, b, stepsize}]],
     {x, a, b}, DisplayFunction -> Identity]];
      Show[one, two, DisplayFunction -> $DisplayFunction])

tangentfamily::usage = "tangentfamily[f, {a, b, stepsize}] plots f and its
tangents on the interval {a, b}, plotting one tangent per stepsize in the
interval {a, b}. The default stepsize is 0.1."
 
normalfamily/: normalfamily[f_, {a_, b_, stepsize_:0.1}, {c_, d_}] := 
   (one = 
    Block[{i, x}, Plot[Release[Table[normal[f, i][x], {i, a, b, stepsize}]],
    {x, a, b}, PlotRange -> {c, d}, AspectRatio -> Automatic,
     DisplayFunction -> Identity]]; 
      two = Block[{x}, Plot[f[x], {x, a, b}, DisplayFunction -> Identity]];
        Show[one, two, DisplayFunction -> $DisplayFunction])
 
normalfamily::usage = "normalfamily[f, {a, b, stepsize}, {c, d}] plots f
and its normals on the interval {a, b}, with PlotRange set at {c, d}. One
normal is plotted per stepsize in the interval {a, b}; the default
stepsize is 0.1." 
 
wire/: wire[x_] := 
   (line = Block[{t}, Plot[70, {t, 0, 100}, DisplayFunction -> Identity]]; 
     point = ListPlot[{{x, 70}}, DisplayFunction -> Identity]; 
     circle = Block[{t}, ParametricPlot[{(x*Cos[t])/(2*Pi) + 25, 
         (x*Sin[t])/(2*Pi) + 25}, {t, 0, 2*Pi}, AspectRatio -> Automatic, 
        DisplayFunction -> Identity]]; 
     square = ListPlot[{{75 - (100 - x)/8, 25 - (100 - x)/8}, 
        {75 - (100 - x)/8, 25 + (100 - x)/8}, 
        {75 + (100 - x)/8, 25 + (100 - x)/8}, 
        {75 + (100 - x)/8, 25 - (100 - x)/8},
        {75 - (100 - x)/8, 25 - (100 - x)/8}},
         PlotJoined -> True,  DisplayFunction -> Identity]; 
     Show[circle, square, line, point, Axes -> None,
        PlotRange -> {{0, 100}, {0, 80}}, PlotLabel -> 
      N[x^2/(4 Pi) + (100 - x)^2/(16)] " = combined area of circle and square",
      DisplayFunction -> $DisplayFunction])
 

 
ladder/: ladder[t_] := ListPlot[{{10 t, 0}, {0, Sqrt[41^2 - (10 t)^2]}},
                        PlotRange -> {{0, 41}, {0, 41}},
                        PlotJoined -> True, AspectRatio -> Automatic]

