anti/: anti[tableofvalues_][1] = 0
 
anti/: anti[tableofvalues_][n_] := 
   anti[tableofvalues][n] = 
    anti[tableofvalues][n - 1] + ((First[Transpose[tableofvalues]][[n]] - 
          First[Transpose[tableofvalues]][[n - 1]])*
        (Last[Transpose[tableofvalues]][[n]] + 
          Last[Transpose[tableofvalues]][[n - 1]]))/2
 
antiderivative/: antiderivative[tableofvalues_, k_] := Block[{i},
   Table[{First[Transpose[tableofvalues]][[i]], anti[tableofvalues][i] + k}, 
    {i, Length[tableofvalues]}]]
 
viewantiderivative/: viewantiderivative[f_, {a_, b_}, initialvalue_] := 
    (one = Block[{x}, Plot[f[x], {x, a, b}, DisplayFunction -> Identity]];
     two = Nest[First, InputForm[one], 5];
     Block[{x},
     ListPlot[antiderivative[two, initialvalue], PlotJoined -> True,
     PlotLabel -> {"an approximate antiderivative of", f[x]}]])
 
viewantiderivative::usage = "viewantiderivative[f, {a, b}, initialvalue]
plots the graph of an approximate antiderivative F of f on the interval {a,
b} with initial condition F[a] = initialvalue. The approximation is based
on applying the Mean Value Theorem to Mathematica's InputForm of the Plot
of f on {a, b}."

antiderivativefamily/: 
  antiderivativefamily[f_, {a_, b_, k_:1}] := 
   (one = Block[{x}, Plot[f[x], {x, a, b}, AspectRatio -> Automatic,
        DisplayFunction -> Identity]]; 
     two = Block[{x}, Integrate[f[x], x] /. x -> a]; 
     three = Block[{x, i}, Plot[Release[Table[Integrate[f[x], x] + i, 
          {i, two - 5, two + 5, k}]], {x, a, b},
                DisplayFunction -> Identity]]; 
     Block[{x}, Show[one, three, PlotLabel -> {"antiderivatives of", f[x]}, 
       DisplayFunction -> $DisplayFunction]])
 
antiderivativefamily::usage = "antiderivativefamily[f, {a, b, k}] plots
F[x] + c, and f[x], on the interval {a, b} where F[x] = Integrate[f[x], x],
for a few values of c differing by k. The default value for k is 1."



 
